// library routines
// Source: http://www.daniweb.com/software-development/c/threads/11049/54093#post54093
// Source: http://1-800-magic.blogspot.com/2008/02/down-with-atoi.html
// $Id: library.c 387 2011-10-16 16:52:50Z andy $

#include "library.h"

int strlen(const char *string) {
	const char *s;

	s = string;
	while (*s)
		s++;
	return s - string;
}

char *strrev(char *str) {
	char *p1, *p2;

	if (!str || !*str)
		return str;

	for (p1 = str, p2 = str + strlen(str) - 1; p2 > p1; ++p1, --p2) {
		*p1 ^= *p2;
		*p2 ^= *p1;
		*p1 ^= *p2;
	}

	return str;
}

char *itoa(int n, char *s, int b) {
	static char digits[] = "0123456789abcdefghijklmnopqrstuvwxyz";
	int i=0, sign;
    
	if ((sign = n) < 0)
		n = -n;

	do {
		s[i++] = digits[n % b];
	} while ((n /= b) > 0);

	if (sign < 0)
		s[i++] = '-';
	s[i] = '\0';

	return strrev(s);
}

int atoi(char *c) {
  int res = 0, neg = 0;
  if (*c == '-')
  {
    neg = 1;
    c++;
  }
  while (*c >= '0' && *c <= '9')
    res = res * 10 + *c++ - '0';
  if (neg) res = -res;
  return res;
}
