// core microcontroller specific functionality
// OpenRadioControl
// (C) BritishIdeas.com 2011 andy@britishideas.com
// This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License
// http://creativecommons.org/licenses/by-nc-sa/3.0/
// THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
// OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
// BRITISHIDEAS SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR
// CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
// $Id: core.h 393 2011-10-17 21:38:31Z andy $

#ifndef _COREH_
#define _COREH_

#include "global.h"

// initialize the microcontroller
extern void Core_Init
  (
	void
	);

// turns the status led on
extern void Core_StatusLEDOn
  (
  void
  );

// turns the status led off
extern void Core_StatusLEDOff
  (
  void
  );

// enable write access to configuration storage
extern void Core_ConfigurationWriteEnable
  (
  void
  );

// disable write access to configuration storage
extern void Core_ConfigurationWriteDisable
  (
  void
  );

// gets the current timestamp in milliseconds
extern uint32_t Core_GetTime
  (
  void
  );

// checks if a timestamp is in the past
// returns true if in the past
extern boolean_t Core_IsTimeExpired
  (
  uint32_t Timestamp                                       // timestamp to check
  );

// returns after waiting a specific number of milliseconds
extern void Core_Delay
  (
  uint32_t Milliseconds                                    // time to wait
  );

// feeds the watchdog to stop the processor from resetting
extern void Core_FeedWatchdog
  (
  void
  );

// checks if the last processor reset was caused by the watchdog or not
// returns true if watchdog reset processor
extern boolean_t Core_IsLastResetFromWatchdog
  (
  void
  );

// resets the microcontroller after a delay
extern void Core_Reset
  (
  void
  );

#endif // _COREH_
