// ppm module
// generates an eight channel ppm waveform for feeding into an rc transmitter
// OpenRadioControl
// (C) BritishIdeas.com 2011 andy@britishideas.com
// This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License
// http://creativecommons.org/licenses/by-nc-sa/3.0/
// THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
// OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
// BRITISHIDEAS SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR
// CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
// $Id: ppm.h 393 2011-10-17 21:38:31Z andy $

#ifndef _PPMH_
#define _PPMH_

// initializes the ppm module
// note: uses timer 0 and 1
extern void PPM_Init
    (
    unsigned int InitialValue,                             // initial value to use for all channels in microseconds
    int Channels                                           // number of channels
    );

// starts the ppm waveform generation
extern void PPM_Start(void);

// stops the ppm waveform generation
extern void PPM_Stop(void);

// sets the value of a channel in microseconds
extern void PPM_SetChannelValue
    (
    unsigned int Channel,                                  // number of channel (0 - 5)
    unsigned int Value                                     // new channel value in microseconds
    );

// gets the current value for a channel
// must not be called while PPM_SetChannel is being executed
// returns the current channel value in microseconds
extern unsigned int PPM_GetChannelValue
    (
    unsigned int Channel                                   // number of channel (0 to NUMCHANNELS - 1)
    );

#endif // _PPMH_
