// serial interface
// OpenRadioControl
// (C) BritishIdeas.com 2011 andy@britishideas.com
// This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License
// http://creativecommons.org/licenses/by-nc-sa/3.0/
// THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
// OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
// BRITISHIDEAS SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR
// CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
// $Id: serial.h 396 2011-10-18 21:51:01Z andy $

#ifndef _SERIALH_
#define _SERIALH_

#include "global.h"

// maximum length of a command
#define SERIAL_MAXCOMMANDLENGTH 50

// supported command responses
typedef enum { Ok, Error } response_t;

// initializes the serial module
extern void Serial_Init
  (
	void
	);

// waits until any pending characters have been transmitted
// warning: a watchdog reset may occur before this function completes
extern void Serial_WaitForTransmitComplete
  (
  void
  );

// sends a response back
extern void Serial_SendResponse
  (
  response_t Response,                                     // response to send back
  boolean_t Wait                                           // false to return immediately, true to wait for transmit to complete
  );

// gets the latest received command
// returns length of command received, zero if no command received
extern int32_t Serial_GetCommand
  (
  char *Command                                            // location to store received command
  );

// transmits a byte
extern void Serial_Send
  (
  uint8_t Value
  );

// transmits a string and appends line termination
extern void Serial_SendString
  (
  char *String                                             // string to transmit
  );

#endif // _SERIALH_
